/*
 * ===========================
 * VDK Visual Development Kit
 * Version 0.4
 * October 1998
 * ===========================
 *
 * Copyright (C) 1998, Mario Motta
 * Developed by Mario Motta <mmotta@guest.net>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#ifndef  TIMER_H
#define  TIMER_H
#include <vdk/vdkobj.h>

class VDKForm;

class VDKTimer: public VDKObject
{
protected:
  static int HandleTimerTick(gpointer obj);
  unsigned int timerId;
  unsigned int tick;
  bool started;
public:
  VDKTimer(VDKForm* owner,unsigned int tick = 1000, bool start = true);
  virtual ~VDKTimer();
  void Start();
  void Stop();
  bool Started() { return started; }
#ifdef USE_SIGCPLUSPLUS
  VDKSignal0<void> OnTimerTick;
  VDKSignal1<void, bool> OnTimerRunning;
#endif /* USE_SIGCPLUSPLUS */
};
#endif
